import EveryTime from './EveryTime';
import { Day } from './helpers';
declare class Task {
    private name;
    private executor;
    constructor(name: string, executor: () => Promise<void>);
    getTimeBuilder(): Builder;
    getName(): string;
    getExecutor(): () => Promise<void>;
}
declare class Builder {
    private cron;
    private runsAt;
    private task;
    constructor(task: Task);
    build(): {
        name: string;
        execute: () => Promise<void>;
    } | undefined;
    private replaceCron;
    at(hhMmStr: string): void;
    onceAt(date: Date | number | string): {
        build: () => {
            name: string;
            execute: () => Promise<void>;
        };
    };
    monthly(): Builder;
    daily(): Builder;
    onSpecificDays(days: string[]): Builder;
    /**
     * Every Minute
     */
    everyMinute(): Builder;
    everyHour(): Builder;
    everyHourAt(minuteOfTheHour: number): Builder;
    everyWeekDay(startDay?: Day | number, endDay?: Day | number): this;
    /**
     * Every Year
     */
    static everyYear(): string;
    /**
     * Every Year In
     * @param monthOfTheYear  - Month of the year
     * @param dayOfTheMonth - Day of the month
     * @param hourOfTheDay - Hour of the day
     * @param minuteOfTheHour - Minute of the hour.
     */
    static everyYearIn(monthOfTheYear: number, dayOfTheMonth?: number, hourOfTheDay?: number, minuteOfTheHour?: number): string;
    /**
     * Between Time Frames
     * @param start - Start
     * @param end - End
     */
    static between(start: number, end: number): EveryTime;
}
export default Task;
//# sourceMappingURL=index.d.ts.map